  subroutine rdwagner_sahara_dust(nopr,iout,indir,outdir,lstrn,iset,&
  lset,llset,nlines,wcm,wavelength,rndat,ridat,iwave)

! ******
! Read in the data from the netCDF file

! ****
! Will use netCDF f90 routines
  use netcdf

! param1.inc gives the maximum size of indices and extinction vectors
  include 'param1.inc'

! ****
! See rdinoutdir.f90
  character(len=60) :: indir,outdir
  integer :: nopr,iout,iset

! See main.f90
  integer :: nlines,iwave
  real :: wcm(nwavemax),wavelength(nwavemax)
  real :: rndat(nwavemax),ridat(nwavemax)
  character(len=100) :: lstrn,lset,filnm

! Used here
  integer,parameter :: ndat=14,ncomp=5
  integer :: id1,istat,noprf,mset,i1,i2
  integer :: idwcm,idwave,idrn,idri,idtk
  integer :: start(1),count(1),stride(1)
  integer :: start2(2),count2(2),stride2(2)
  integer :: ntext,n70
  real :: hematite(ncomp)
  real :: wcmdat(ndat),wavedat(ndat)
  real :: rnval(ndat,ncomp),rival(ndat,ncomp)
  character(len=30) :: fil
  character (len=16) :: files(ncomp)
  character (len=16) :: llset

! ***
! Read in the data from the netCDF file
   lset=lstrn

! ***
! The input netCDF file
!     '123456789012345678901234567890'
  fil='wagner_sahara_dust.nc         '

! Obtain the full pathname of the input netCDF file
   noprf=0
  call getfilnm(noprf,iout,fil,indir,filnm)
  if (noprf .eq. 1) then
   stop
  end if

! ***
! Open the netCDF file
  istat=nf90_open(filnm,nf90_nowrite,id1)
   call handle(iout,istat)

  if (nopr .eq. 1) then
   write(iout,fmt=100) id1,filnm
   100 format(/,2x,"rdwagner_sahara_dust: id1,filnm ",i8,2x,a100)
  end if

! ***
! Get dimension ids (work with variables part of ncdump)
  istat=nf90_inq_varid(id1,'ncases',idncases)
   call handle(iout,istat)
  istat=nf90_inq_varid(id1,'nwav',idnwav)
   call handle(iout,istat)
  istat=nf90_inq_varid(id1,'ntext',idntext)
   call handle(iout,istat)
  istat=nf90_inq_varid(id1,'n70',idn70)
   call handle(iout,istat)

! *****
! Get the dimensions
  istat=nf90_get_var(id1,idncases,ncases)
   call handle(iout,istat)
  istat=nf90_get_var(id1,idnwav,nwav)
   call handle(iout,istat)
  istat=nf90_get_var(id1,idntext,ntext)
   call handle(iout,istat)
  istat=nf90_get_var(id1,idn70,n70)
   call handle(iout,istat)
  
  if (nopr .eq. 1) then
   write(iout,fmt=110) ncases,nwav
   110 format(/,2x,"ncases,nwav ",/,&
   2x,4(1x,i4))
   write(iout,fmt=120) ntext,n70
   120 format(/,2x,"ntext,n70",/,&
   2x,2(1x,i4))
  end if

! ***
! Obtain the listing of the compounds
! Will ask the user to choose which compound to work with

! The different compositions
!          '1234567890123456'
  files(1)='Wagner Bakina Fa'
  files(2)='Wagner Cairo 2  '  
  files(3)='Wagner SANUM B1 '
  files(4)='Wagner SANUM B2 '
  files(5)='Wagner SANUM B3 ' 

! *
! Write out the compounds included in the netCDF file
  write(0,fmt=140)
  140 format(2x," Will select mset value for a specific case")
  write(0,fmt=145)
  145 format(2x," i, case ")

  do i=1,ncomp
   write(0,fmt=150) i,files(i)
   150 format(2x,i3,2x,a40)
  end do

  write(0,fmt=160)
  160 format(2x,"Specify mset (1-5) ")

  read(5,*) mset
  mset=int(mset)

! The compound string
  llset=files(mset)

  write(0,fmt=170) mset,llset
  170 format(2x," mset,llset ",i4,2x,a16)

! ***
! Obtain variable ids
   istat=nf90_inq_varid(id1,'hematite',idhematite)
    call handle(iout,istat)
   istat=nf90_inq_varid(id1,'wcm',idwcm)
    call handle(iout,istat)
   istat=nf90_inq_varid(id1,'wavelength',idwave)
    call handle(iout,istat)
   istat=nf90_inq_varid(id1,'refn',idrn)
    call handle(iout,istat)
   istat=nf90_inq_varid(id1,'refi',idri)
    call handle(iout,istat)

  if (nopr .eq. 1) then
   write(0,fmt=190) idhematite,idwcm,idwave,idrn,idri
   write(iout,fmt=190) idhematite,idwcm,idwave,idrn,idri
   190 format(/,2x,"idhematite,idwcm,idwave,idrn,idri ",/,&
   2x,5(1x,i4))
  end if 

! ****
!  Read in the data
   start(1)=1
   count(1)=ncomp
   stride(1)=1
  istat=nf90_get_var(id1,idhematite,hematite,start,count,stride)
   call handle(iout,istat)

   start(1)=1
   count(1)=ndat
   stride(1)=1
  istat=nf90_get_var(id1,idwcm,wcmdat,start,count,stride)
   call handle(iout,istat)
  istat=nf90_get_var(id1,idwave,wavedat,start,count,stride)
   call handle(iout,istat)

   start2(1)=1
   start2(2)=1
   count2(1)=ndat
   count2(2)=ncomp
   stride2(1)=1
   stride2(2)=1
  istat=nf90_get_var(id1,idrn,rnval,start2,count2,stride2)
   call handle(iout,istat)
  istat=nf90_get_var(id1,idri,rival,start2,count2,stride2)
   call handle(iout,istat)

! ****
! Exit define mode
  istat=nf90_enddef(id1)

! Close the data set
  istat=nf90_close(id1)

! *****
! Specify how many lines to work with
  nlines=ndat

  write(0,fmt=700) nlines
  write(iout,fmt=700) nlines
  700 format(/,2x,"nlines ",i4)

! *****
! Put values into the output arrays
  do i=1,nlines
   wcm(i)=wcmdat(i)
   wavelength(i)=wavedat(i)
   rndat(i)=rnval(i,mset)
   ridat(i)=rival(i,mset)
  end do

! *****
  if (nopr .eq. 1) then
    write(iout,fmt=800) mset,files(mset),hematite(mset)
    800 format(/,2x,"rdwagner_sahara_dust: work with mset, files(mset)",/,&
    2x,i3,2x,a16,/,&
    2x,"rdwagner_sahara_dust: hematite(mset) ",f10.4)
    write(iout,fmt=840)
    840 format(2x,"rdwagner_sahara_dust: i,wcm,wavelength,rndat,ridat")
   do i=1,nlines 
    write(iout,fmt=850) i,wcm(i),wavelength(i),rndat(i),ridat(i)
    850 format(2x,i4,2(1x,f10.4),1p,2(1x,e10.3))
   end do
  end if

! ******
  return
  end
